/* categoryList.h
 */
#ifndef _CATEGORYLIST_H
#define _CATEGORYLIST_H

#include "osl/category/categoryConcept.h"

namespace osl
{
  namespace category
  {
    class NullCategory{};

    template <class L,class R>
    struct CategoryList;

    template <class T>
    struct IsCategoryList
    {
      static const bool isCategoryList=false;
    };
    template<>
    struct IsCategoryList<NullCategory>
    {
      static const bool isCategoryList=true;
    };
    template<class L, class R>
    struct IsCategoryList<CategoryList<L,R> >{
      static const bool isCategoryList=true;
    };

    /**
     * ܤ Loki  Typelist 
     * õ(MTDF, AlphaBeta)MoveGenerator Ѥ
     * å򤷤ΤǶŪ̾ˤƤ
     */
    template <class L, class R=NullCategory>
    struct CategoryList
    {
      BOOST_CLASS_REQUIRE(L,osl::category,CategoryConcept);
      BOOST_STATIC_ASSERT(category::IsCategoryList<R>::isCategoryList);
    };
  } // namespace category
  using category::CategoryList;
  using category::NullCategory;
  
} // namespace osl


#endif /* _CATEGORYLIST_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
