/* promote.h
 */
#ifndef _CATEGORY_PROMOTE_H
#define _CATEGORY_PROMOTE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/category/probTable.h"

namespace osl
{
  namespace category
  {
    /**
     * ̤ promote
     *
     * capture θǳΨϤäƤΤǡư϶
     */
    struct Promote : public StandardProbabilityCategory
    {
      static Interpolator<PieceValueTable> probTable;
      static const char *getName() { return "Promote"; }
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	return move.promoteMask() 
	  && (env.state->getPieceOnBoard(move.to()) == Piece::EMPTY());
      }
    };

  } // namespace category
} // namespace osl

#endif /* _CATEGORY_PROMOTE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
