/* blockingSimulation.h
 */
#ifndef _BLOCKING_SIMULATION_H
#define _BLOCKING_SIMULATION_H

#include "osl/state/numEffectState.h"
#include "osl/hash/hashKey.h"
namespace osl
{
  class PathEncoding;
  namespace checkmate
  {
    class CheckHashRecord;
    class CheckMove;
    /**
     * @param P ¦
     */
    template <Player P>
    struct BlockingSimulation
    {
      /** ߤζ̤ record   move ؤ
       * Ρɤ oracle õƥߥ졼󤹤 
       */
      template <class Table>
      static bool proof(NumEffectState& state, 
			const HashKey& new_key, const PathEncoding& new_path,
			const CheckHashRecord *record, Table& table,
			const CheckMove& move, size_t& node_count);
      /** 
       * oracle ǵͤˡoracle.move.to() Ʊ郎
       * ͤफɤ򥷥ߥ졼󤹤롥
       */
      template <class Table>
      static void proofSibling(NumEffectState& state, 
			       const HashKey& key, const PathEncoding& path,
			       CheckHashRecord *record, Table& table,
			       const CheckMove& oracle, size_t& node_count);
    private:
      /**
       * target ؤ塤guide ƱͤˤĤफɤΤ
       */
      template <class Table>
      static bool proof(NumEffectState& state, 
			const HashKey&, const PathEncoding&, Table& table, 
			const CheckMove& target, const CheckHashRecord *guide,
			size_t& node_count);

    };
  } // namespace checkmate
} // namespace osl

#endif /* _BLOCKING_SIMULATION_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
