/* proofPiecesUtil.h
 */
#ifndef _PROOFPIECESUTIL_H
#define _PROOFPIECESUTIL_H

#include "osl/pieceStand.h"
#include "osl/state/simpleState.h"

namespace osl
{
  namespace checkmate
  {
    class CheckMoveList;
    /**
     * ProofPieces  DisproofPieces ˶̤δؿ
     */
    struct ProofPiecesUtil
    {
      /**
       * alt(player) äƤʤλ playeräƤ
       * out ʬû롥
       */
      static 
      void addMonopolizedPieces(const SimpleState& state, Player player,
				const PieceStand max, PieceStand& out)
      {
	const Player opponent = alt(player);
	for (unsigned int i=0; i<PieceStand::order.size(); ++i)
	{
	  const Ptype ptype = PieceStand::order[i];
	  if (! state.hasPieceOnStand(opponent, ptype))
	  {
	    const int diff = max.get(ptype) - out.get(ptype);
	    assert(diff >= 0);
	    if (diff)
	      out.add(ptype, diff);
	  }
	}
      }
    };
  } // namespace checkmate
} // osl

#endif /* _PROOFPIECESUTIL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
