#ifndef OSL_ADDITIONAL_EFFECT_H
#define OSL_ADDITIONAL_EFFECT_H
#include "osl/state/numEffectState.h"
namespace osl
{
  namespace container
  {
    class PieceVector;
  }
  namespace effect_util
  {
    using container::PieceVector;
    /**
     * ɲ
     */
    struct AdditionalEffect
    {
    private:
      static void find(const NumEffectState&, Position target, 
		       const PieceVector& direct_effects,
		       PieceVector& black, PieceVector& white);
      template <int count_max>
      static int count(const NumEffectState&, Position target, 
		       Player attack);
    public:
      /**
       * target  attack ɲĤǤ⤢뤫
       * αˤоݤȤʤ
       */
      static bool hasEffect(const NumEffectState&, Position target, 
			    Player attack);
      /**
       * target  attack ɲĤޤǿ.
       * αζʹߤоݤȤʤ
       */
      static int count2(const NumEffectState&, Position target, 
			      Player attack);
      /**
       * target ФɲΤ Piece  black, white ˵.
       * [*] +KI -HI +HI ξ硤-HI+HI⥫.
       */
      static void find(const NumEffectState&, Position target, 
		       PieceVector& black, PieceVector& white);
      static void count(const NumEffectState&, Position target,
			int& black, int& white);
      static int count(const NumEffectState& state, Player pl, Position target)
      {
	int black, white;
	count(state, target, black, white);
	return (pl == BLACK) ? black : white;
      }
    };
  } // namespace effect_util
  using effect_util::AdditionalEffect;
} // namespace osl

#endif /* OSL_ADDITIONAL_EFFECT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
