/* neighboring25Direct.h
 */
#ifndef EFFECT_UTIL_NEIGHBORING25DIRECT_H
#define EFFECT_UTIL_NEIGHBORING25DIRECT_H

#include "osl/state/simpleState.h"

namespace osl
{
  namespace effect_util
  {
    class Neighboring25Direct
    {
    private:
      static bool hasEffectFromTo(const SimpleState& state,
				  PtypeO ptypeo, Position from, 
				  Position target, Offset offset);
    public:
      static bool hasEffectNaive (const SimpleState& state,
				  PtypeO ptypeo, Position from, 
				  Position target);
      static bool hasEffect(const SimpleState& state,
			    PtypeO ptypeo, Position from, 
			    Position target)
      {
	return hasEffectNaive(state, ptypeo, from, target);
      }
      
    };
  } // namespace effect_util
  using effect_util::Neighboring25Direct;
} // namespace osl

#endif /* _NEIGHBORING25_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
