#ifndef _MOVE_GENERATOR_ADD_EFFECT_H
#define _MOVE_GENERATOR_ADD_EFFECT_H
#include "osl/move_generator/drop.h"
#include "osl/move_generator/addEffectTable.h"
#include <boost/static_assert.hpp>

namespace osl
{
  namespace move_action
  {
    class Store;
  }
  namespace move_generator
  {
    /**
     * AddEffect  ­ûΥ.
     */
    template<Player P,Ptype T,bool isAttackToKing=false>
    struct AddEffectShort
    {
      BOOST_STATIC_ASSERT((PtypeTraits<T>::isBasic));
      BOOST_STATIC_ASSERT((PtypeTraits<T>::canPromote));
      /**
       * ­ûˤ
       * @param P(template) - ¦Υץ쥤䡼
       * @param T(template) - Ptype T promoteˤ
       * @param state - 
       * @param target - Ĥޥ
       * @param action - ꤬callbackؿ
       * @param nearMask - target10˵Υޥ
       */
      template<class State,class Action>
      static void generate(const State& state,Position target,Action& action,NearMask nearMask);
    };
    
    /**
     * AddEffect  ­ĹΥ.
     */
    template<Player P,Ptype T,bool isAttackToKing=false>
    struct AddEffectLong
    {
      BOOST_STATIC_ASSERT((PtypeTraits<T>::isBasic));
      /**
       * ĹĤ
       */
      template<class State,class Action>
      static void generate(const State& state,Position target,Action& action,NearMask nearMask);
    };
    

    /**
     * ʤstateǻȤAddEffect.
     * isAttackToKingtrueξKINGˤ벦ϼʤΤʤ
     * ʬμ꤬꤫ɤΥå򤹤뤫
     * isAttackToKing falseλϡɲ
     * ɲϴ֤˶1Ĥޤ
     * isAttackToKingfalseλϡɲopen attackʣƤޤȤ롥
     * 르ꥺ:
     * \li ǽĤޥ10˵(8˵+)ξ(Ũ)Ĵ٤
     * \li 40Ĥ٤Ƥζ˴ؤơ׾μʬζξ
     *   ĤޥȤΰ֤κʬ(Offset32)׻ơ֥򻲾Ȥ
     * \li ޥ10˵ξ֤Ӥ뤳ȤˤꡤζȤäդ
     *   ʤ
     * ħ:
     * \li ʿŪˤΤstateǻȤäƤAddEffectWithEffect®
     * \li ̤μͳ٤ۤȤɤʤʤɤAddEffectWithEffect®Ȥ⤢롥
     */
    template<Player P,bool isAttackToKing=false>
    class AddEffect
    {
      // BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      // BOOST_STATIC_ASSERT(sizeof(typename State::simple_board_t));
    public:
      /**
       * promoteȤϴطʤ
       */
      template<class State,class Action>
      static void generateKing(const State& state,Position target,Action& action,NearMask nearMask);
      template<class State,class Action>
      static void generateGold(const State& state,Position target,Action& action,NearMask nearMask);
      /**
       * оݤȤޥդ
       * @param P(template) - ֤Υץ쥤䡼
       * @param state - оݤȤ
       * @param target - Ĥޥ
       * @param action - ꤬¸ߤ˸ƤӽФХåؿ
       */
      template<class State,class Action>
      static void generate(const State& state,Position target,Action& action);
    };

    template<bool isAttackToKing=false>
    struct GenerateAddEffect
    {
      /**
       * оݤȤޥդ.
       * SafeFilter 򤫤롥
       * Note: Action PlayerǷդƤȡ̵̤ΤStore
       */
      template<class State>
      static void generate(Player player, const State& state, Position target, 
			   move_action::Store& store);
    };
  } // namespace move_generator
} // namespace osl
#endif /* _MOVE_GENERATOR_ADD_EFFECT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
