#ifndef _GENERATE_OPEN_MOVES_H
#define _GENERATE_OPEN_MOVES_H
#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_action/concept.h"
#include "osl/state/simpleState.h"
#include <boost/static_assert.hpp>
// Open<StoreMoveAction> ʳȤ߹碌ǻȤȤ
// open.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace move_generator
  {
    /**
     * ĹߤƤư, 򿭤Ф.
     * 
     * ư, Position to褦ʤΤϼ
     */
    template<Player P>
    class Open
    {
      // BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      // BOOST_STATIC_ASSERT(sizeof(typename State::simple_board_t));

      template<class Action,Ptype Type,PromoteType CanP,Direction Dir,bool B>
      static void generateMoveNotDir3(const SimpleState& state,Piece p,Action& action,Position to,Int2Type<B>);

      template<class Action,Ptype Type,PromoteType CanP,Direction Dir>
      static void generateMoveNotDir3(const SimpleState& state,Piece p,Action& action,Position to,Int2Type<true>);

      template<class Action,Ptype Type,PromoteType CanP,Direction Dir>
      static void generateMoveNotDir3(const SimpleState&, Piece, Action&, Position, Int2Type<false>){
	// no call
      }

      template<class Action,Ptype Type,Direction Dir,PromoteType CanP,Direction MoveDir>
      static void generateMoveNotDir2(const SimpleState& state,Piece p,Action& action,Position to){
	generateMoveNotDir3<Action,Type,CanP,MoveDir>(state,p,action,to,
						 Int2Type<Dir!=DirectionTraitsGen<MoveDir>::primDir && PtypeDirectionTraits<Type,MoveDir>::hasMove>());
      }

      template<class Action,Ptype Type,Direction Dir,PromoteType CanP>
      static void generateMoveNotDir1(const SimpleState& state,Piece p,Action& action,Position to){
	generateMoveNotDir2<Action,Type,Dir,CanP,UL>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,U>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,UR>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,L>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,R>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,DL>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,D>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,DR>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,UUL>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,UUR>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_UL>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_U>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_UR>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_L>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_R>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_DL>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_D>(state,p,action,to);
	generateMoveNotDir2<Action,Type,Dir,CanP,LONG_DR>(state,p,action,to);
      }

      template<class Action,Ptype Type,Direction Dir>
      static void generateMoveNotDirSub(const SimpleState& state,Piece p,Action& action,Position to,Int2Type<true>){
	if (p.position().template canPromote<P>())
	  generateMoveNotDir1<Action,Type,Dir,CanPromoteType>(state,p,action,to);
	else{
	  // DirectionˤäƤcheck
	  generateMoveNotDir1<Action,Type,Dir,CheckPromoteType>(state,p,action,to);
	}
      }

      template<class Action,Ptype Type,Direction Dir>
      static void generateMoveNotDirSub(const SimpleState& state,Piece p,Action& action,Position to,Int2Type<false>){
	generateMoveNotDir1<Action,Type,Dir,NoPromoteType>(state,p,action,to);
      }

    public:
      template<class Action,Ptype Type,Direction Dir>
      static void generateMoveNotDir(const SimpleState& state,Piece p,Action& action,Position to);


      /**
       * fromˤpDirʳưӤ
       * toФΤϽ
       */
      template<class Action,Direction Dir>
      static void generateOpenAttack(const SimpleState& state,Position from,Piece p,Action& action,Position to);

      template<class Action>
      static void generate(const SimpleState& state,Position from,Piece p,Action& action,Position to,Direction dir);
      
    };

    struct GenerateOpen
    {
      template<class Action>
      static void 
      generate(Player pl,const SimpleState& state,Position from,Piece p,
	       Action& action,Position to,Direction dir)
      {
	if (pl == BLACK)
	  Open<BLACK>::generate(state, from, p, action, to, dir);
	else
	  Open<WHITE>::generate(state, from, p, action, to, dir);
      }
    };
    
  } // namespace move_generator
} // namespace osl
#endif /* _GENERATE_OPEN_MOVES_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
