/* dotAnalyzerAll.h
 */
#ifndef _DOTANALYZERALL_H
#define _DOTANALYZERALL_H

#include "osl/search/analyzer/dotAnalyzer.h"

namespace osl
{
  class MoveLogProb;
  namespace search
  {
    class SimpleHashRecord;
    namespace analyzer
    {
      /**
       * õΥơ֥ʬ.
       * limit Ƥμ
       */
      class DotAnalyzerAll : public DotAnalyzer
      {
      public:
	DotAnalyzerAll(const SimpleHashTable&, std::ostream&);
	~DotAnalyzerAll();

	void analyze(const HashKey& root, int limit);
	void analyzeQuiescence(const HashKey& root);
      private:
	/**
	 * ̾õΥΡɤˬ
	 */
	void visit(const HashKey&, int limit,
		   const SimpleHashRecord *from, 
		   const MoveLogProb& move);
	/**
	 * ŻõΥΡɤˬ
	 */
	void visitQuiescence(const HashKey&, int moveId,
			     const SimpleHashRecord *from, 
			     Move move);
      };
    } // namespace analyzer
  } // namespace search
} // namespace osl


#endif /* _DOTANALYZERALL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
