/* Preconditioner.cc
 */
#include "osl/stat/preconditioner.h"
#include <algorithm>
/* ------------------------------------------------------------------------- */

osl::stat::
Preconditioner::Preconditioner()
{
}

osl::stat::
Preconditioner::~Preconditioner()
{
}

/* ------------------------------------------------------------------------- */

osl::stat::
IdentityPreconditioner::IdentityPreconditioner(size_t dim)
  : m_dim(dim)
{
}

osl::stat::
IdentityPreconditioner::~IdentityPreconditioner()
{
}

// MANIPULATORS
// ACCESSORS
void osl::stat::
IdentityPreconditioner::solve(const double*x, double *out) const
{
  std::copy(x, x+m_dim, out);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
