#include "osl/ntesuki/pdNtesukiResult.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <string>
#include <sstream>

using namespace osl;
using namespace osl::ntesuki;

class PdNtesukiResultTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(PdNtesukiResultTest);
  CPPUNIT_TEST(testGenerate);
  CPPUNIT_TEST_SUITE_END();
  
public:
  void testGenerate()
  {
    PdNtesukiResult nr;
    nr = ProofDisproof::NoCheckmate();
    nr = ProofDisproof::Checkmate();
    nr = ProofDisproof(1, 1);
  }
};

CPPUNIT_TEST_SUITE_REGISTRATION(PdNtesukiResultTest);

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
