#include "osl/player.h"
#include <iostream>
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
using namespace osl;
extern bool isShortTest;

class playerTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( playerTest );
  CPPUNIT_TEST( testAlt );
  CPPUNIT_TEST( testShow );
  CPPUNIT_TEST_SUITE_END();
 public:
  void testAlt();
  void testShow();
};

CPPUNIT_TEST_SUITE_REGISTRATION(playerTest);

void playerTest::testAlt(){
  CPPUNIT_ASSERT( alt(BLACK)==WHITE );
  CPPUNIT_ASSERT( alt(WHITE)==BLACK );
}

void playerTest::testShow(){
  if (! isShortTest)
  {
    std::cout << BLACK << std::endl;
    std::cout << WHITE << std::endl;
  }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
