/* doUndoMoveLockFoward.h
 */
#ifndef _DOUNDOMOVELOCKFOWARD_H
#define _DOUNDOMOVELOCKFOWARD_H

namespace osl
{
  namespace apply_move
  {
  // Implementations are dependent on each State.
  // It is important not to provide default implementations,
  // so as to detect missing implementation in link error
  template <class State>  struct DoUndoMoveLockSimple;
  template <class State>  struct DoUndoMoveLockCapture;
  template <class State>  struct DoUndoMoveLockDrop;
  } // namespace apply_move
} // namespace osl

#endif /* _DOUNDOMOVELOCKFOWARD_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
