/* textPerformanceLog.h
 */
#ifndef OSL_TEXTPERFORMANCELOG_H
#define OSL_TEXTPERFORMANCELOG_H

#include "osl/misc/log/performanceLog.h"

/**
 * mtdfstat, alphabetastat $BMQ$N5-O?MQ(B (text)
 * 
 */
namespace osl
{
  namespace misc
  {
    namespace log
    {
  struct TextPerformanceLog : public PerformanceLog
  {
    TextPerformanceLog();
    ~TextPerformanceLog();
    void record(const char *name, Move correctMove,
		Move result, unsigned int nodes,
		unsigned long long clocks,
		int depth);
  };
    }
  }
} // namespace osl


#endif /* OSL_TEXTPERFORMANCELOG_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
