/* attackDefenceAroundKing.h
 */
#ifndef _ATTACK_DEFENCE_AROUND_KING_MC_H
#define _ATTACK_DEFENCE_AROUND_KING_MC_H

#include "osl/effect_util/neighboring25Direct.h"
#include "osl/state/simpleState.h"
#include "osl/direction.h"

namespace osl
{
  namespace move_classifier
  {
    /**
     * ̤μ 5x5 ΰĤ
     * - P  move  player Ȱ̤ˤϰפʤΤ
     * - TODO 5x5 ΰǤζΰưޤ᤿ɤ
     * -- Open Moves?
     * -- 
     * -- (ͽ)礤ΰ֤֤Ƥ
     */
    template <Player P>
    struct AttackDefenceAroundKing
    {
      static bool
      isMember(const SimpleState& state, Move move)
      {
	const PtypeO ptypeO = move.ptypeO();
	Position from = move.to();
	Position king = state.template getKingPosition <P> ();
	
	return Neighboring25Direct::hasEffect(state, ptypeO, from, king);
      }
    };
  } // namespace move_classifier
  
} // namespace osl

#endif /* _ATTACK_DEFENCE_AROUND_KING_MC_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
