/* openCheck.h
 */
#ifndef _MOVE_CLASSIFIER_OPENCHECK_H
#define _MOVE_CLASSIFIER_OPENCHECK_H
#include "osl/state/simpleState.h"
#include "osl/move_classifier/kingOpenMove.h"

namespace osl
{
  namespace move_classifier
  {
    template <Player P>
    struct OpenCheck
    {
      static bool isMember(const SimpleState& state, 
			   Ptype ptype,Position from,Position to)
      {
	return KingOpenMove<PlayerTraits<P>::opponent>::isMember
	  (state,ptype,from,to);
      }
    };
  } // namespace move_classifier
} // namespace osl

#endif /* _MOVE_CLASSIFIER_OPENCHECK_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
