/* pawn.cc
 */
#include "osl/category/pawn.h"
#include "osl/category/probTableDefine.h"

namespace osl
{
  namespace category
  {
    DEF_CATEGORY_TABLE(FixedValueTable, ForwardPawnWithRookSupport);
    DEF_CATEGORY_TABLE(FixedValueTable, DanglingPawn);
    DEF_CATEGORY_TABLE(FixedValueTable, GambitPawn);
    DEF_CATEGORY_TABLE(FixedValueTable, JoiningPawns);
    DEF_CATEGORY_TABLE(FixedValueTable, DropAfterOpposingPawn);
    DEF_CATEGORY_TABLE(FixedValueTable, ImmediateAntiPawnPromotion);
    DEF_CATEGORY_TABLE(FixedValueTable, SideAttack);
    DEF_CATEGORY_TABLE(FixedValueTable, SideAttackDrop);
    DEF_CATEGORY_TABLE(FixedValueTable, PawnBeforePawn);
    DEF_CATEGORY_TABLE(FixedValueTable, AnchorPawn);
    DEF_CATEGORY_TABLE(FixedValueTable, MoveSaGWithPawn);
    DEF_CATEGORY_TABLE(FixedValueTable, PawnStopBishopEffect);
    DEF_CATEGORY_TABLE(FixedValueTable, PawnOnLance);
    DEF_CATEGORY_TABLE(FixedValueTable, PawnOnSilver);
    DEF_CATEGORY_TABLE(FixedValueTable, PawnAttackBase);
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
