#include "osl/move_generator/open.h"
#include "osl/move_generator/open.tcc"
#include "osl/move_action/store.h"
#include "osl/move_action/safeFilter.h"
#include "osl/state/simpleState.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  // explicit template instantiation
  template void move_generator::GenerateOpen::generate
  (Player, const SimpleState&, Position, Piece, move_action::Store&,
   Position, Direction);

  template void move_generator::Open<BLACK>::generate
  (const SimpleState&, Position, Piece,
   move_action::SafeFilter<BLACK,NumEffectState,move_action::Store>&,
   Position,Direction);
  template void move_generator::Open<WHITE>::generate
  (const SimpleState&, Position, Piece,
   move_action::SafeFilter<WHITE,NumEffectState,move_action::Store>&,
   Position,Direction);
#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
  template void move_generator::Open<BLACK>::generate<move_action::Store>(SimpleState const&, Position, Piece, move_action::Store&, Position, Direction);
  template void move_generator::Open<WHITE>::generate<move_action::Store>(SimpleState const&, Position, Piece, move_action::Store&, Position, Direction);
#endif
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
