#include "osl/search/quiescenceSearch.h"
#include "osl/search/quiescenceSearch.tcc"
#include "osl/search/quiescenceWindow.tcc"
#include "osl/checkmate/dualCheckmateSearcher.h"
#include "osl/eval/progressEval.h"
#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
#  include "osl/eval/eachPlayerAttackDefense.h"
#endif

namespace osl
{
  template class search::QuiescenceSearch<eval::PieceEval>;
  template class search::QuiescenceSearch<eval::ProgressEval>;
#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
  template class search::QuiescenceSearch<eval::EachPlayerAttackDefense>;
#endif

  template int search::QuiescenceSearch<eval::PieceEval>::searchProbCut<BLACK>(int, int, eval::PieceEval const&, Move);
  template int search::QuiescenceSearch<eval::PieceEval>::searchProbCut<WHITE>(int, int, eval::PieceEval const&, Move);
  template int search::QuiescenceSearch<eval::ProgressEval>::searchProbCut<BLACK>(int, int, eval::ProgressEval const&, Move);
  template int search::QuiescenceSearch<eval::ProgressEval>::searchProbCut<WHITE>(int, int, eval::ProgressEval const&, Move);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
