/* sparseInstance.cc
 */
#include "osl/stat/sparseInstance.h"
#include <iostream>

std::ostream& osl::stat::operator<<(std::ostream& os, const SparseInstance& v)
{
  os << "[";
  for (SparseInstance::const_iterator p=v.begin(); p!=v.end(); ++p)
  {
    os << "( " << p->index << " " << p->value << " ) ";
  }
  return os << "]";
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
