#include "osl/misc/carray.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
using namespace osl;

class CArrayTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE( CArrayTest );
  CPPUNIT_TEST(testCallConstructor);
  CPPUNIT_TEST_SUITE_END();
public:
  void testCallConstructor();
};

CPPUNIT_TEST_SUITE_REGISTRATION(CArrayTest);
extern bool isShortTest;

namespace
{
  struct Count
  {
    static int count;
    Count()
    {
      ++count;
    }
  };
  int Count::count = 0;
}

void CArrayTest::testCallConstructor()
{
  CPPUNIT_ASSERT_EQUAL(0, Count::count);
  CArray<Count,4> a;
  CPPUNIT_ASSERT_EQUAL(4, Count::count);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
